#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include </usr/include/semaphore.h>
#include <unistd.h>

#define BUF_SIZE   10           /* total number of slots */
#define MAX 100
int buf[BUF_SIZE];      /* shared var */
sem_t full;             /* keep track of the number of full spots */
sem_t empty;            /* keep track of the number of empty spots */
pthread_mutex_t mutex;  /* enforce mutual exclusion to shared data */


void *Producer(void *arg) {
  int i, item;
  
  for (i=0; i < MAX; i++) {
    sem_wait(&empty);     /* If there are no empty slots, wait */
    
    pthread_mutex_lock(&mutex);  /* If another thread uses the buffer, wait */
    buf[i%BUF_SIZE] = item = rand() % 100;
    printf("[P] Producing %d ...\n", item);
    pthread_mutex_unlock(&mutex);  /* Release the buffer */
    sem_post(&full);               /* Increment the number of full slots */
    usleep(700);
  }
  return NULL;
}

void *Consumer(void *arg) {
  int i, item, index;
  
  for (i=0; i < MAX; i++) {
    sem_wait(&full);                /* If the buffer is empty, wait */
    pthread_mutex_lock(&mutex);     /* If another thread uses the buffer, wait */
    item=buf[i%BUF_SIZE];
    printf("[C] Consuming  %d ...\n", item);
    pthread_mutex_unlock(&mutex);   /* Release the buffer */
    sem_post(&empty);               /* Increment the number of free slots */
    usleep(1000);
  }
  return NULL;
}

int main() {
  pthread_t idP, idC;
  
  sem_init(&full, 0, 0);
  sem_init(&empty, 0, BUF_SIZE);
  pthread_mutex_init(&mutex, NULL);
  pthread_create(&idP, NULL, Producer, NULL);
  pthread_create(&idC, NULL, Consumer, NULL);
  
  pthread_join(idP, NULL);
  pthread_join(idC, NULL);
}
